commit 1355ea504983c04bbf44e01f63d1059f3df0ad7a
Author: Eric Botcazou <ebotcazou@adacore.com>
Date:   Tue Sep 14 11:10:17 2021

    Fix inaccurate bounds in debug info for vector array types
    
    They should not be 0-based, unless the array type itself is.
    
    gcc/ada/
            * gcc-interface/decl.c (gnat_to_gnu_entity): For vector types, make
            the representative array the debug type.

diff --git a/gcc/ada/gcc-interface/decl.c b/gcc/ada/gcc-interface/decl.c
index d901529fd24..c71d0d6f396 100644
--- a/gcc/ada/gcc-interface/decl.c
+++ b/gcc/ada/gcc-interface/decl.c
@@ -4745,6 +4745,14 @@ gnat_to_gnu_entity (Entity_Id gnat_entity, tree gnu_expr, bool definition)
       else
 	gnu_decl = create_type_decl (gnu_entity_name, gnu_type, artificial_p,
 				     debug_info_p, gnat_entity);
+
+      /* For vector types, make the representative array the debug type.  */
+      if (VECTOR_TYPE_P (gnu_type))
+	{
+	  tree rep = TYPE_REPRESENTATIVE_ARRAY (gnu_type);
+	  TYPE_NAME (rep) = DECL_NAME (gnu_decl);
+	  SET_TYPE_DEBUG_TYPE (gnu_type, rep);
+	}
     }
 
   /* Otherwise, for a type reusing an existing DECL, back-annotate values.  */

